<template>
  <q-item
    :key="`item-${fertilizationPlan.id}`"
    clickable
    @click="onClickConfigure"
  >
    <q-item-section>
      <q-list
        :padding="false"
        :bordered="false"
        class="full-width"
      >
        <q-item
          class="q-pa-none"
        >
          <q-item-section>
            <q-item-label
              lines="1"
              class="ellipsis"
            >
              {{ fertilizationPlan.name || fertilizationPlan.plot.name }}
            </q-item-label>

            <q-item-label class="text-grey ellipsis">
              <q-icon
                name="la la-draw-polygon"
              />
              {{ fertilizationPlanResults.plot_name }}
            </q-item-label>
            <q-item-label class="text-grey ellipsis">
              <q-icon
                name="lab la-pagelines"
              />
              {{ fertilizationPlanResults.plant_species_name }}
            </q-item-label>
          </q-item-section>
          <q-item-section
            side
            top
          >
            <q-item-label
              caption
              style="padding-top: 2px;"
            >
              <span>{{ displayFromNow(fertilizationPlan.updated_at) }}</span>
            </q-item-label>
          </q-item-section>
        </q-item>

        <q-item
          v-if="npkElements"
          class="q-pa-none"
        >
          <q-item-section>
            <div class="col-auto row no-wrap">
              <NPKBadge
                v-for="(element, index) in npkElements"
                :key="'fertilization-plan-'+fertilizationPlan.id+'-card-' + element.chemical_element_id"
                :element-id="element.chemical_element_id"
                :formula-id="element.chemical_formula_id"
                :quantity="element.quantity"
                :min="element.quantity_min"
                :max="element.quantity_max"
                large
                :class="{'q-mr-xs': index < npkElements.length - 1}"
              />
            </div>
          </q-item-section>
        </q-item>
      </q-list>
    </q-item-section>
    <q-item-section
      side
    >
      <q-icon name="las la-angle-right" />
    </q-item-section>
  </q-item>
</template>

<script>
import { DateMixin } from 'src/mixins/DateMixin'
import NPKBadge from 'src/components/npk/NPKBadge'
import { npkChemicalElementIds, resultTypes, getDisplayUnit, convertResults } from 'src/services/fieldbook/fertilization/fertilizationPlan'

export default {
  name: 'FertilizationPlanListItem',
  mixins: [DateMixin],
  components: {
    NPKBadge
  },
  props: {
    fertilizationPlan: {
      type: Object,
      required: true
    }
  },
  computed: {
    fertilizationPlanResults () {
      const results = this.fertilizationPlan.results
      if (results instanceof Array) {
        return results?.[0]
      } else if ('plot_id' in results && 'element_recommendations' in results) {
        return results
      } else if ('npk_recommendations' in results) {
        // the result is a map plotId => results: get the first entry
        return Object.values(results.npk_recommendations)?.[0]
      } else {
        return {}
      }
    },
    recommendations () {
      return (this.fertilizationPlanResults?.element_recommendations || [])
        .filter(recommendation => npkChemicalElementIds.includes(recommendation.chemical_element_id.toUpperCase()))
    },
    recommendationNpkElements () {
      return this.getNpkElements(resultTypes.RECOMMENDATION)
    },
    balanceNpkElements () {
      return this.getNpkElements(resultTypes.BALANCE)
    },
    npkElements () {
      // show balance or recommendation according to the display parameters
      if (this.includePlannedFertilization && this.balanceNpkElements?.length) {
        return this.balanceNpkElements
      } else {
        return this.recommendationNpkElements
      }
    },
    includePlannedFertilization () {
      return this.$store.state.appState.includePlannedFertilization
    },
    displayUnitConfig () {
      return this.fertilizationPlanResults?.display_unit_config
    },
    displayUnit () {
      return getDisplayUnit(this.displayUnitConfig)
    },
    selectedLanguageCode () {
      return this.$store.state.fastplatform.preferredLanguage
    }
  },
  methods: {
    onClickConfigure () {
      this.$router.push({ name: 'fertilizationPlan', params: { fertilizationPlanId: this.fertilizationPlan.id } })
    },
    onClickViewResults () {
      this.$router.push({ name: 'fertilizationPlanResults', params: { fertilizationPlanId: this.fertilizationPlan.id } })
    },
    getNpkElements (resultType) {
      return convertResults(this.recommendations.filter(recommendation => recommendation.result_type === resultType), this.displayUnitConfig)
    }
  }
}
</script>
